/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_QMPARSE_H_INCLUDED
# define YY_YY_QMPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    STRING = 258,                  /* STRING  */
    LINE = 259,                    /* LINE  */
    INTERACT = 260,                /* INTERACT  */
    SOURCE = 261,                  /* SOURCE  */
    AS = 262,                      /* AS  */
    CONST = 263,                   /* CONST  */
    DEF = 264,                     /* DEF  */
    ELSE = 265,                    /* ELSE  */
    EXTERN = 266,                  /* EXTERN  */
    FROM = 267,                    /* FROM  */
    IF = 268,                      /* IF  */
    IMPORT = 269,                  /* IMPORT  */
    INCLUDE = 270,                 /* INCLUDE  */
    OTHERWISE = 271,               /* OTHERWISE  */
    PRIVATE = 272,                 /* PRIVATE  */
    PUBLIC = 273,                  /* PUBLIC  */
    SPECIAL = 274,                 /* SPECIAL  */
    THEN = 275,                    /* THEN  */
    TYPE = 276,                    /* TYPE  */
    UNDEF = 277,                   /* UNDEF  */
    VAR = 278,                     /* VAR  */
    VIRTUAL = 279,                 /* VIRTUAL  */
    WHERE = 280,                   /* WHERE  */
    DOTDOT = 281,                  /* DOTDOT  */
    EQUIV = 282,                   /* EQUIV  */
    OP0 = 283,                     /* OP0  */
    OP1 = 284,                     /* OP1  */
    OP2 = 285,                     /* OP2  */
    OP3 = 286,                     /* OP3  */
    OP4 = 287,                     /* OP4  */
    OP5 = 288,                     /* OP5  */
    OP6 = 289,                     /* OP6  */
    OP7 = 290,                     /* OP7  */
    OP8 = 291,                     /* OP8  */
    OP9 = 292,                     /* OP9  */
    _DEF_ = 293,                   /* _DEF_  */
    _UNDEF_ = 294,                 /* _UNDEF_  */
    _VAR_ = 295,                   /* _VAR_  */
    _IMPORT_ = 296,                /* _IMPORT_  */
    _COPYING_ = 297,               /* _COPYING_  */
    _HELP_ = 298,                  /* _HELP_  */
    _EDIT_ = 299,                  /* _EDIT_  */
    _PATH_ = 300,                  /* _PATH_  */
    _PROMPT_ = 301,                /* _PROMPT_  */
    _HISTFILE_ = 302,              /* _HISTFILE_  */
    _HISTSIZE_ = 303,              /* _HISTSIZE_  */
    _CSTACKSIZE_ = 304,            /* _CSTACKSIZE_  */
    _STACKSIZE_ = 305,             /* _STACKSIZE_  */
    _MEMSIZE_ = 306,               /* _MEMSIZE_  */
    _STATS_ = 307,                 /* _STATS_  */
    _RUN_ = 308,                   /* _RUN_  */
    _SAVE_ = 309,                  /* _SAVE_  */
    _LOAD_ = 310,                  /* _LOAD_  */
    _CLEAR_ = 311,                 /* _CLEAR_  */
    _PROFILE_ = 312,               /* _PROFILE_  */
    _BREAK_ = 313,                 /* _BREAK_  */
    _TBREAK_ = 314,                /* _TBREAK_  */
    _DEBUG_ = 315,                 /* _DEBUG_  */
    _UNPARSE_ = 316,               /* _UNPARSE_  */
    _ECHO_ = 317,                  /* _ECHO_  */
    _CHDIR_ = 318,                 /* _CHDIR_  */
    _PWD_ = 319,                   /* _PWD_  */
    _LS_ = 320,                    /* _LS_  */
    _WHICH_ = 321,                 /* _WHICH_  */
    _SOURCE_ = 322,                /* _SOURCE_  */
    _WHO_ = 323,                   /* _WHO_  */
    _WHOS_ = 324,                  /* _WHOS_  */
    _WHOIS_ = 325,                 /* _WHOIS_  */
    _IMPORTS_ = 326,               /* _IMPORTS_  */
    _MODULES_ = 327,               /* _MODULES_  */
    _COMPLETION_MATCHES_ = 328,    /* _COMPLETION_MATCHES_  */
    _DEC_ = 329,                   /* _DEC_  */
    _HEX_ = 330,                   /* _HEX_  */
    _OCT_ = 331,                   /* _OCT_  */
    _STD_ = 332,                   /* _STD_  */
    _SCI_ = 333,                   /* _SCI_  */
    _FIX_ = 334,                   /* _FIX_  */
    _FORMAT_ = 335,                /* _FORMAT_  */
    XID = 336,                     /* XID  */
    QID = 337,                     /* QID  */
    NID = 338,                     /* NID  */
    STR = 339,                     /* STR  */
    INT = 340,                     /* INT  */
    FLOAT = 341,                   /* FLOAT  */
    ARG = 342,                     /* ARG  */
    ERRTOK = 343,                  /* ERRTOK  */
    ARGERR = 344,                  /* ARGERR  */
    STRERR = 345                   /* STRERR  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define STRING 258
#define LINE 259
#define INTERACT 260
#define SOURCE 261
#define AS 262
#define CONST 263
#define DEF 264
#define ELSE 265
#define EXTERN 266
#define FROM 267
#define IF 268
#define IMPORT 269
#define INCLUDE 270
#define OTHERWISE 271
#define PRIVATE 272
#define PUBLIC 273
#define SPECIAL 274
#define THEN 275
#define TYPE 276
#define UNDEF 277
#define VAR 278
#define VIRTUAL 279
#define WHERE 280
#define DOTDOT 281
#define EQUIV 282
#define OP0 283
#define OP1 284
#define OP2 285
#define OP3 286
#define OP4 287
#define OP5 288
#define OP6 289
#define OP7 290
#define OP8 291
#define OP9 292
#define _DEF_ 293
#define _UNDEF_ 294
#define _VAR_ 295
#define _IMPORT_ 296
#define _COPYING_ 297
#define _HELP_ 298
#define _EDIT_ 299
#define _PATH_ 300
#define _PROMPT_ 301
#define _HISTFILE_ 302
#define _HISTSIZE_ 303
#define _CSTACKSIZE_ 304
#define _STACKSIZE_ 305
#define _MEMSIZE_ 306
#define _STATS_ 307
#define _RUN_ 308
#define _SAVE_ 309
#define _LOAD_ 310
#define _CLEAR_ 311
#define _PROFILE_ 312
#define _BREAK_ 313
#define _TBREAK_ 314
#define _DEBUG_ 315
#define _UNPARSE_ 316
#define _ECHO_ 317
#define _CHDIR_ 318
#define _PWD_ 319
#define _LS_ 320
#define _WHICH_ 321
#define _SOURCE_ 322
#define _WHO_ 323
#define _WHOS_ 324
#define _WHOIS_ 325
#define _IMPORTS_ 326
#define _MODULES_ 327
#define _COMPLETION_MATCHES_ 328
#define _DEC_ 329
#define _HEX_ 330
#define _OCT_ 331
#define _STD_ 332
#define _SCI_ 333
#define _FIX_ 334
#define _FORMAT_ 335
#define XID 336
#define QID 337
#define NID 338
#define STR 339
#define INT 340
#define FLOAT 341
#define ARG 342
#define ERRTOK 343
#define ARGERR 344
#define STRERR 345

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 95 "qmparse.y"

  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  struct {
    int n, m;
  } lval;
  struct {
    char **v;
    int c;
  } aval;

#line 261 "qmparse.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_QMPARSE_H_INCLUDED  */
